#include <alloc.h>
#include <stddef.h>

#define POINTER uint32_t
#define BUCKET_NUM 256
#define BUCKET_SIZE 6371

unsigned int highest_size = 0;
// TODO determine this
void* malloc_base_pointer = (void*) 0x01000000;
#define table(BUCKET, SLOT) hashtable[(BUCKET*BUCKET_NUM)+SLOT]

malloc_entry* hashtable = (void*) 0x100000;

void init_hashtable() {
	memset((uint8_t*)hashtable, 0, 0xE00000);
}

void* malloc(uint32_t size) {
	if(size == 0) return NULL;
	// TODO not hardcode this
	if(highest_size > 1073742000) return NULL;
	malloc_entry candidate_entry = (malloc_entry) {NULL, 0xFFFFFFFF, 0};
	int candidate_slot = 0xFFFFFF, foundpage = 0;
	if(size > highest_size) goto nocandidate;
	// TODO search more efficiently? maybe hashtable[0x10000][0x100]?
	// TODO combining nearby blocks
	// TODO if block is at highest pointer update hash table instead of reallocating
	for(int bi = 0; bi < 256; bi++) {
		for(int si = 0; si < BUCKET_SIZE; si++) {
			if(
				table(bi,si).state == MALLOC_FREE &&
				table(bi,si).size < candidate_entry.size &&
				table(bi,si).size >= size
			) {
				candidate_entry = table(bi,si);
				candidate_entry.size = size;
		//		candidate_bucket = bi;
				candidate_slot = si;
			}
		}
	}
	if(candidate_slot == 0xFFFFFF) {
		nocandidate:
		candidate_entry = (malloc_entry) {malloc_base_pointer + highest_size + 1, size, MALLOC_USED};
		highest_size += size;
		for(candidate_slot = 0; candidate_slot < BUCKET_SIZE; candidate_slot++) if(
			table((POINTER) candidate_entry.ptr & 0xFF,candidate_slot).ptr == NULL &&
			table((POINTER) candidate_entry.ptr & 0xFF,candidate_slot).state == 0
		) {foundpage = 1; break;}
		if(!foundpage) return NULL;
	} else candidate_entry.state = MALLOC_USED;
	table((POINTER) candidate_entry.ptr & 0xFF,candidate_slot) = candidate_entry;
	if(size > highest_size) highest_size = size;
	return candidate_entry.ptr;
}

void free(void* ptr) {
	if(ptr != NULL) for(int i = 0; i < BUCKET_SIZE; i++) if(table((POINTER) ptr & 0xFF,i).ptr == ptr) {
		table((POINTER) ptr & 0xFF,i).state = MALLOC_FREE;
	}
}

void* realloc(void* ptr, uint32_t size) {
	if(ptr != NULL) for(int i = 0; i < BUCKET_SIZE; i++) if(table((POINTER) ptr & 0xFF,i).ptr == ptr) {
		if(size <= table((POINTER) ptr & 0xFF,i).size) return ptr;
		free(ptr);
		void* newptr = malloc(size);
		memcpy(newptr, ptr, table((POINTER) ptr & 0xFF,i).size);
		return newptr;
	}
	return NULL;
}
