#include <ports.h>
#include <video.h>
#include <keyboard.h>
#include <interrupt.h>
#include <ata-pio.h>
#include <alloc.h>
#include <video.h>
#include <stdlib.h>

uint32_t tick = 0;

void clock_update(registers* r) {
	tick++;
	for(int i = 0; i < 80 * 25; i++) {((uint16_t*)0xB8000)[i] = 0xF000 | (tick & 0xFF);}
}

void setclock(uint32_t f) {
	uint32_t divisor = 1193182 / f;
	outb(0x43, 0x36);
	outb(0x40, divisor & 0xFF);
	outb(0x40, (divisor >> 8) & 0xFF);
}

void entry() {
	isr_init();
	regint(32, clock_update);
	kbmode(1);
	setclock(8);

	while(1) for(int i = 0; i < 80 * 25; i++) {
		((uint16_t*)0xB8000)[i] = 0xF000 | (tick & 0xFF);
	}
}
